############
 # Script to upload representatives from a csv
 # Called from import_elected.py & upload-representatives-changelists (admin)
############
from ast import Try
import os
from csv import DictReader
from warnings import catch_warnings
from risefor_lobbying.models import *
from django.core.management.base import BaseCommand
from django.db.models import Value
from django.db.models.functions import Concat
from django.conf import settings

import requests # to get image from the web
import shutil # to save it locally                  
import risefor_lobbying


def uploadRepresentatives(representattiveDict):
    i = 0
    for row in representattiveDict:
        try:
            fullName = row["prénom"] + " "+ row["nom"]
        except KeyError:
            fullName = row["nom_complet"]
        print(fullName)
        # already_created = Representative.objects.filter(firstname__iexact=row["PRENOM"],
        #                                                 lastname__iexact=row["NOM"]).exists()
        already_created = Representative.objects.filter(fullname__iexact=fullName).exists()
        # try:
        #     already_created = Representative.objects.filter(fullname__iexact=row["FULL NAME"]).exists()
        # except KeyError:
        
        if already_created:
            print("L'élue ",fullName," existe, passage en mode mise à jour")
            # representative = Representative.objects.filter(fullname__iexact=row["FULL NAME"]).get()
            representative = Representative.objects.filter(fullname__iexact=fullName).get()
            # print("representative is",representative)
        
        if not already_created:
            print("L'élue ",fullName," n'existe pas et va être créé")
            representative = Representative()
        

        #############
        # Global fields
        #############
        civility = row["sexe"]
        representative.civility = row["sexe"]
        try:
            representative.firstname = row["prénom"]
        except KeyError:
            pass
        try:
            representative.lastname = row["nom"]
        except KeyError:
            pass
        print("Nom complet",row["nom_complet"])
        if row["nom_complet"] == '':
            representative.fullname = row["prénom"] + " " + row["nom"]
        else:
            representative.fullname = row["nom_complet"]
        # title #TODO a ajouter dans le fichier, == titre global, ie président assemblée
        
        if row["groupe"] != '':
            representative.politicalParty = row["groupe"]
        else :
            representative.politicalParty = row["groupe_sigle"]

        #groupe_sigle #TODO ajouter dans le model
        # slug
        representative.election_department = row["nom_deptmt"]
        #add num département?
        representative.election_region  = row["nom_region"]
        #rename address en 'adresse permanence'
        representative.address1  = row["adresse_permanence"]
        representative.postal_code = row["cp_permanence"]
        representative.city = row["ville_permanence"]
        
        representative.circonscription = row["nom_circo"] + " n° " + row["num_circo"]
        representative.allPostalCodes  = row["Codes_postaux"]
        
        # Handle Country
        if row["pays"] == '':
            row["pays"] = "France"
        if row["pays"]:
            #get the country model
            countries = Countrie()                        
            countryCheck = Countrie.objects.filter(name__iexact=row["pays"]).exists()
            existingCountry = Countrie.objects.all()
            
            if countryCheck is True:
                representative.representativeCountry = existingCountry.get(name__iexact=row["pays"])
            else:
                countries.name = row["pays"]
                countries.country = row["pays"]
                countries.save()
                representative.representativeCountry = existingCountry.get(name__iexact=countries.name)
            representative.save()   

        #upload image
        if row["photo"] != '' :
            print("photo",row["photo"])
            image_url = row["photo"]
            filename = representative.fullname.replace(" ","-")
            filename = "Representatives/"+filename+".png"
            filename = filename.replace("/","-")
            #print("filename",filename)
            fileurl = filename
            fileDownloadPath = "./media/"+filename
            filename = filename

            # Open the url image, set stream to True, this will return the stream content.
            r = requests.get(image_url, stream = True)

            # Check if the image was retrieved successfully
            if r.status_code == 200:
                # Set decode_content value to True, otherwise the downloaded image file's size will be zero.
                r.raw.decode_content = True
                
                # Open a local file with wb ( write binary ) permission.
                with open(fileDownloadPath,'wb') as f:
                    shutil.copyfileobj(r.raw, f)
                    
                print('Image sucessfully Downloaded: ',filename,f)
                print("image file url is",fileurl)
                representative.photo = filename
            else:
                print('Image Couldn\'t be retreived')
        else:
            if representative.civility is not '':
                if ("Mme" in representative.civility):
                    representative.photo = "/default/avatar_f.png"
                else:
                    representative.photo = "/default/avatar_h.png"
            else:
                representative.photo = "/default/avatar_h.png"
            print("picture is",representative.photo)

        #handle function
        if row["function"]:
            function = representativeFunction()
            functionCheck = representativeFunction.objects.filter(name__iexact=row["function"]).exists()
            existingFunction = representativeFunction.objects.all()
            
            #print("the function is" , row["function"] ,"and",functionCheck)
            if functionCheck is True:
                representative.function = existingFunction.get(name__iexact=row["function"])
            else:
                function.name = row["function"]
                function.save()
                representative.function = existingFunction.get(name__iexact=function.name)

        ##########
        # Postes parlementaires (commissions, groupes d'études, etc)
        ##########
        #Commission permanente
        if row["commission_permanente"] != '':
            commission = commissionPermanente()
            commissionCheck = commissionPermanente.objects.filter(name__iexact=row["commission_permanente"]).exists()
            existingCommission = commissionPermanente.objects.all()
            
            #print("the commission is" , row["COMMISSION PERMANENTE"] ,"and",exists)
            if commissionCheck is True:
                representative.permanentCommission = existingCommission.get(name__iexact=row["commission_permanente"])
            else:
                commission.name = row["commission_permanente"]
                commission.save()
                representative.permanentCommission = existingCommission.get(name__iexact=commission.name)

        if row["commission_permanente_function"] != '':
            commissionFunction = parliamentaryPosition()
            commissionFunctionCheck = parliamentaryPosition.objects.filter(name__iexact=row["commission_permanente_function"]).exists()
            existingCommissionFunction = parliamentaryPosition.objects.all()
            
            #print("the commission is" , row["COMMISSION PERMANENTE"] ,"and",exists)
            if commissionFunctionCheck is True:
                representative.permanentCommissionFunction = existingCommissionFunction.get(name__iexact=row["commission_permanente_function"])
            else:
                commissionFunction.name = row["commission_permanente_function"]
                commissionFunction.save()
                representative.permanentCommissionFunction = existingCommissionFunction.get(name__iexact=commissionFunction.name)

        #missions parlementaires
        if row["missions_parlementaires"]:
            #get the Parliamentary Mission model
            ParliamentaryMission = missionParlementaire()
            #get the values of missions in column
            thisRepresentativeMissions = row["missions_parlementaires"].split(";")
            #get all exiting parliamentaryMissions
            existingParliamentaryMissions = missionParlementaire.objects.all()

            #for each new value, check if it exists
            for thisRepresentativeMission in thisRepresentativeMissions:
                ######### 
                # CLEAN NAME && EXTRACT POST IF IT'S THERE
                    #1st, remove post that is between parenthasis (president, vice, etc)
                thisRepresentativeMission = thisRepresentativeMission.split("(")
                thisRepresentativeMission = thisRepresentativeMission[0]  

                ######### 
                # HANDLE CREATION OF NEW OBJECT 
                exists = existingParliamentaryMissions.filter(name__iexact=thisRepresentativeMission).exists()
                
                #if it doesn't exist, 
                if exists is False:
                    # create it
                    ParliamentaryMission.name = thisRepresentativeMission
                    ParliamentaryMission.id = uuid.uuid4().int & (1<<45)-1
                    ParliamentaryMission.urlid = '' 
                    ParliamentaryMission.save()
                
                #add the mission to the representative's model
                representative.parliamentaryMissions.add(missionParlementaire.objects.filter(name__iexact=thisRepresentativeMission)[0])

        #groupe d'éludes
        if row["groupe_etude"]:
            #get the Study group model
            studyGroups = groupeEtude()
            #get the values of missions in column
            thisRepresentativeGroups = row["groupe_etude"].split(";")
            #for each new value, check if it exists
            for thisRepresentativeGroup in thisRepresentativeGroups: 
                ######### 
                # CLEAN NAME && EXTRACT POST IF IT'S THERE
                    #1st, remove post that is between parenthasis (president, vice, etc)
                thisRepresentativeGroup = thisRepresentativeGroup.split("(")
                thisRepresentativeGroup = thisRepresentativeGroup[0]  

                #print("groupe étude",thisRepresentativeGroup)
                #get all exiting studyGroups
                existingStudyGroups = groupeEtude.objects.all()
                exists = existingStudyGroups.filter(name__iexact=thisRepresentativeGroup).exists()
                #if it doesn't exist, 
                if exists is False:
                    # create it
                    #print("existing",existingStudyGroups.filter(name__iexact=thisRepresentativeGroup))
                    studyGroups.name = thisRepresentativeGroup
                    studyGroups.id = uuid.uuid4().int & (1<<45)-1
                    studyGroups.urlid = studyGroups.name
                    studyGroups.save()
                #add the mission to the representative's model
                representative.studyGroups.add(groupeEtude.objects.filter(name__iexact=thisRepresentativeGroup)[0])
        
        ##############
        # Info de contacts
        #############
        
        #############
        #TODO : CHECK IF EMAIL ALREADY EXISTS, IF SO PASS
        #############
        if row["emails"]:
            email = Email()
            allEmails = Email.objects.all()
            #get emails related to the representative
            if (";" in row["emails"]) or ("\n" in row["emails"]) or ("|" in row["emails"]) :
                if ("\n" in row["emails"]):
                    emails = row["emails"].split("\n")
                elif ("|" in row["emails"]):
                    emails = row["emails"].split("|")
                else:
                    emails = row["emails"].split(";")
                for newEmail in emails:
                    newEmail = newEmail.replace(" ","")
                    emailCheck = Email.objects.filter(name__iexact=newEmail).exists()
                    # print("email check is",emailCheck)
                    # if newEmail:
                    if emailCheck is False:
                        # print("creating email")
                        email.name = newEmail.lower()
                        email.representative = representative
                        email.save()
                    else:
                        print("email exists")
            else:
                newEmail = row["emails"].replace(" ","")
                emailCheck = Email.objects.filter(name__iexact=newEmail).exists()
                print("email check is",emailCheck)
                # if newEmail:
                if emailCheck is False:
                    print("creating email")
                    email.name = newEmail.lower()
                    email.representative = representative
                    email.save()
                else:
                    print("email exists")
        
        
        if row["twitter"]:
            newTwitter = row["twitter"]
            newTwitter = newTwitter.replace("[","")
            newTwitter = newTwitter.replace("]","")
            newTwitter = newTwitter.replace("'","")

            twitter = TwitterAccount()

            if newTwitter:
                if (";" in newTwitter) or ("," in newTwitter) or ("|" in newTwitter):
                    if ";" in newTwitter:
                        twitterAccounts = newTwitter.split(";")
                    elif "," in newTwitter:
                        twitterAccounts = newTwitter.split(",")
                    elif "|" in newTwitter:
                        twitterAccounts = newTwitter.split("|")
                        
                    for newTwitter in twitterAccounts:
                        twitterCheck = TwitterAccount.objects.filter(name__iexact=newTwitter).exists()

                        if twitterCheck is False:
                            twitter.name = newTwitter
                            twitter.representative = representative
                            twitter.save()

                else:
                    twitterCheck = TwitterAccount.objects.filter(name__iexact=newTwitter).exists()
                    if twitterCheck is False:   
                        twitter.name = newTwitter   
                        twitter.representative = representative
                        twitter.save()
        
        if row["tel"]:
            newPhone = row["tel"]
            newPhone = newPhone.replace("[","")
            newPhone = newPhone.replace("]","")
            newPhone = newPhone.replace("'","")
            if newPhone:
                if (";" in newPhone) or ("," in newPhone):
                    if ";" in newPhone:
                        phones = newPhone.split(";")
                    if "," in newPhone:
                        phones = newPhone.split(",")
                        
                    for newPhone in phones:
                        newPhone = newPhone.replace(" ","")
                        newPhone = newPhone.replace("-","")
                        phoneCheck = Phone.objects.filter(name__iexact=newPhone).exists()

                        if phoneCheck is False:
                            phone = Phone()
                            phone.name = newPhone
                            phone.representative = representative
                            phone.save()

                else:
                    phoneCheck = Phone.objects.filter(name__iexact=newPhone).exists()
                    if phoneCheck is False:
                        phone = Phone()
                        phone.name = newPhone
                        phone.representative = representative
                        phone.save()

        representative.website = row["website"]
        representative.facebook = row["facebook"]
        representative.profession = row["profession"].replace("[","").replace("]","")

        representative.save()
        
        # # ###For dev
        # i+= 1
        # if i > 5:
        #     break





